﻿namespace ProjectMonorail.Scripts.Monorail.Drawnings
{
    public class DrawningMonorailCompareByColor : IComparer<DrawingMonorail?>
    {
        public int Compare(DrawingMonorail? x, DrawingMonorail? y)
        {
            if (x == null || x.EntityMonorail == null)
            {
                return 1;
            }

            if (y == null || y.EntityMonorail == null)
            {
                return -1;
            }
            var bodycolorCompare = x.EntityMonorail.BodyColor.Name.CompareTo(y.EntityMonorail.BodyColor.Name);
            if (bodycolorCompare != 0)
            {
                return bodycolorCompare;
            }
            var speedCompare = x.EntityMonorail.Speed.CompareTo(y.EntityMonorail.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return x.EntityMonorail.Weight.CompareTo(y.EntityMonorail.Weight);
        }
    }
}
